//  -*- Mode: Java -*-
//
// /tmp/build-stella/new-stella/native/java/edu/isi/stella/GeneralizedSymbol.java

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2002      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

package edu.isi.stella;

import edu.isi.stella.javalib.*;

public abstract class GeneralizedSymbol extends ContextSensitiveObject {
    public String symbolName;
    public int symbolId;

  public static StringWrapper idlTranslateSymbolConstantId(GeneralizedSymbol symbol) {
    { StringWrapper translatedsymbol = GeneralizedSymbol.idlTranslateSymbolConstantName(symbol);

      translatedsymbol.wrapperValue = translatedsymbol.wrapperValue + "_id";
      return (translatedsymbol);
    }
  }

  public static StringWrapper idlTranslateSymbolConstantName(GeneralizedSymbol symbol) {
    { String prefix = null;

      { Surrogate testValue000 = Stella_Object.safePrimaryType(symbol);

        if (Surrogate.subtypeOfSymbolP(testValue000)) {
          { Symbol symbol000 = ((Symbol)(symbol));

            prefix = "SYM_" + ((Module)(symbol000.homeContext)).contextName();
          }
        }
        else if (Surrogate.subtypeOfSurrogateP(testValue000)) {
          { Surrogate symbol000 = ((Surrogate)(symbol));

            prefix = "SGT_" + ((Module)(symbol000.homeContext)).contextName();
          }
        }
        else if (Surrogate.subtypeOfKeywordP(testValue000)) {
          { Keyword symbol000 = ((Keyword)(symbol));

            prefix = "KWD";
          }
        }
        else {
          { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

            stream000.nativeStream.print("`" + testValue000 + "'" + " is not a valid case option");
            throw StellaException.newStellaException(stream000.theStringReader());
          }
        }
      }
      return (Stella.wrapString(Stella.idlSubstituteForbiddenCharacters(prefix + "_" + symbol.symbolName, Stella.KWD_UPPERCASE)));
    }
  }

  public static String idlChangeCase(GeneralizedSymbol symbol, Keyword caseconvention) {
    { Module module = ((Module)(symbol.homeContext));
      String name = symbol.symbolName;

      if (module == null) {
        module = ((Module)(Stella.$MODULE$.get()));
      }
      if (module.caseSensitiveP) {
        return (Native.string_copy(name));
      }
      if (caseconvention == Stella.KWD_UPPERCASE) {
        return (Native.stringUpcase(name));
      }
      else if (caseconvention == Stella.KWD_LOWERCASE) {
        return (Native.stringDowncase(name));
      }
      else if (caseconvention == Stella.KWD_CAPITALIZED) {
        return (Native.stringCapitalize(name));
      }
      else {
        { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

          stream000.nativeStream.print("`" + caseconvention + "'" + " is not a valid case option");
          throw StellaException.newStellaException(stream000.theStringReader());
        }
      }
    }
  }

  public static StringWrapper idlTranslateClassName(GeneralizedSymbol namesymbol) {
    return (Stella.wrapString(Stella.idlSubstituteForbiddenCharacters(GeneralizedSymbol.idlChangeCase(((Stella_Class)(namesymbol.surrogatify().surrogateValue)).classType, Stella.KWD_CAPITALIZED), Stella.KWD_CAPITALIZED)));
  }

  public static StringWrapper javaTranslateClassName(GeneralizedSymbol namesymbol) {
    return (StandardObject.javaTranslateTypeSpec(namesymbol.surrogatify()));
  }

  public static StringWrapper javaTranslateSymbolConstantId(GeneralizedSymbol symbol) {
    { StringWrapper translatedsymbol = GeneralizedSymbol.javaTranslateSymbolConstantName(symbol);

      translatedsymbol.wrapperValue = translatedsymbol.wrapperValue + "_id";
      return (translatedsymbol);
    }
  }

  public static StringWrapper javaTranslateSymbolConstantName(GeneralizedSymbol symbol) {
    { GeneralizedSymbol globalsymbol = ((GeneralizedSymbol)(Stella.$SYMBOL_REGISTRY$.lookup(symbol)));
      String translatedname = "";

      if (!(globalsymbol != null)) {
        {
          Stella.STANDARD_WARNING.nativeStream.println("Warning: " + "Couldn't lookup symbol name for " + "`" + symbol + "'");
          Stella.STANDARD_WARNING.nativeStream.println("     in java-translate-symbol-constant-name");
        }
;
      }
      translatedname = Module.javaYieldFlotsamClassName(globalsymbol.homeModule()) + "." + Stella.javaSubstituteForbiddenCharacters(globalsymbol.symbolName, Stella.KWD_UPPERCASE);
      if (!Module.inCurrentJavaPackageP(globalsymbol.homeModule())) {
        translatedname = Module.javaPackagePrefix(globalsymbol.homeModule(), ".") + translatedname;
      }
      return (Stella.wrapString(translatedname));
    }
  }

  public static String javaChangeCase(GeneralizedSymbol symbol, Keyword caseconvention) {
    { Module module = ((Module)(symbol.homeContext));
      String name = symbol.symbolName;

      if (module == null) {
        module = ((Module)(Stella.$MODULE$.get()));
      }
      if (module.caseSensitiveP ||
          (!(Stella.computeSymbolEscapeCode(name, Stella.FALSE) == Stella.KWD_UNESCAPED))) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_NO, Stella.KWD_NO, "- ", "", "", "", "", Stella.KWD_PRESERVE, "_"));
      }
      if (caseconvention == Stella.KWD_UPPERCASE) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_NO, Stella.KWD_NO, "- ", "", "", "", "", Stella.KWD_UPCASE, "_"));
      }
      else if (caseconvention == Stella.KWD_LOWERCASE) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_CLEVER, Stella.KWD_CLEVER, "- ", "", "", "", "", Stella.KWD_TITLECASEX, ""));
      }
      else if (caseconvention == Stella.KWD_CAPITALIZED) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_CLEVER, Stella.KWD_CLEVER, "- ", "", "", "", "", Stella.KWD_TITLECASE, ""));
      }
      else {
        { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

          stream000.nativeStream.print("`" + caseconvention + "'" + " is not a valid case option");
          throw StellaException.newStellaException(stream000.theStringReader());
        }
      }
    }
  }

  public static StringWrapper cppTranslateClassName(GeneralizedSymbol namesymbol) {
    return (StandardObject.cppTranslateTypeSpec(namesymbol.surrogatify()));
  }

  public static StringWrapper cppTranslateClassTypename(GeneralizedSymbol namesymbol) {
    { Surrogate realnamesymbol = ((Stella_Class)(namesymbol.surrogatify().surrogateValue)).classType;

      return (Stella.wrapString(Stella.cppYieldQualifiedName(Stella.cppSubstituteForbiddenCharacters(GeneralizedSymbol.cppChangeCase(realnamesymbol, Stella.KWD_CAPITALIZED), Stella.KWD_CAPITALIZED), realnamesymbol)));
    }
  }

  public static StringWrapper cppTranslateSymbolConstantId(GeneralizedSymbol symbol) {
    { StringWrapper translatedsymbol = GeneralizedSymbol.cppTranslateSymbolConstantName(symbol);

      translatedsymbol.wrapperValue = translatedsymbol.wrapperValue + "_id";
      return (translatedsymbol);
    }
  }

  public static StringWrapper cppTranslateSymbolConstantName(GeneralizedSymbol symbol) {
    { String prefix = null;

      { Surrogate testValue000 = Stella_Object.safePrimaryType(symbol);

        if (Surrogate.subtypeOfSymbolP(testValue000)) {
          { Symbol symbol000 = ((Symbol)(symbol));

            prefix = "SYM_" + ((Module)(symbol000.homeContext)).contextName();
          }
        }
        else if (Surrogate.subtypeOfSurrogateP(testValue000)) {
          { Surrogate symbol000 = ((Surrogate)(symbol));

            prefix = "SGT_" + ((Module)(symbol000.homeContext)).contextName();
          }
        }
        else if (Surrogate.subtypeOfKeywordP(testValue000)) {
          { Keyword symbol000 = ((Keyword)(symbol));

            prefix = "KWD";
          }
        }
        else {
          { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

            stream000.nativeStream.print("`" + testValue000 + "'" + " is not a valid case option");
            throw StellaException.newStellaException(stream000.theStringReader());
          }
        }
      }
      return (Stella.wrapString(Stella.cppSubstituteForbiddenCharacters(prefix + "_" + symbol.symbolName, Stella.KWD_UPPERCASE)));
    }
  }

  public static boolean cppQualifyNameP(GeneralizedSymbol namesymbol) {
    { Module symbolmodule = ((Module)(namesymbol.homeContext));
      Module namespacemodule = ((((Module)(Stella.$CPP_CURRENT_UNIT_MODULE$.get())) != null) ? ((Module)(Stella.$CPP_CURRENT_UNIT_MODULE$.get())) : ((Module)(Stella.$MODULE$.get())));

      if ((symbolmodule == null) ||
          (namesymbol == Stella.SYM_STELLA_NULL)) {
        return (Stella.FALSE);
      }
      if (((Keyword)(Stella.$CPP_NAME_QUALIFICATION_MODE$.get())) == Stella.KWD_FULL) {
        return (Stella.TRUE);
      }
      else if (((Keyword)(Stella.$CPP_NAME_QUALIFICATION_MODE$.get())) == Stella.KWD_NEVER) {
        return (Stella.FALSE);
      }
      else if (((Keyword)(Stella.$CPP_NAME_QUALIFICATION_MODE$.get())) == Stella.KWD_CLEVER) {
        if (symbolmodule == namespacemodule) {
          return (Stella.FALSE);
        }
        else if (!Context.visibleFromP(symbolmodule, namespacemodule)) {
          return (Stella.TRUE);
        }
        else {
          { Surrogate testValue000 = Stella_Object.safePrimaryType(namesymbol);

            if (Surrogate.subtypeOfSymbolP(testValue000)) {
              { Symbol namesymbol000 = ((Symbol)(namesymbol));

                return (!(Stella.lookupVisibleSymbolsInModule(namesymbol000.symbolName, namespacemodule, Stella.FALSE).rest == Stella.NIL));
              }
            }
            else if (Surrogate.subtypeOfSurrogateP(testValue000)) {
              { Surrogate namesymbol000 = ((Surrogate)(namesymbol));

                return (!(Stella.lookupVisibleSurrogatesInModule(namesymbol000.symbolName, namespacemodule, Stella.FALSE).rest == Stella.NIL));
              }
            }
            else {
              { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

                stream000.nativeStream.print("`" + testValue000 + "'" + " is not a valid case option");
                throw StellaException.newStellaException(stream000.theStringReader());
              }
            }
          }
        }
      }
      else {
        { OutputStringStream stream001 = OutputStringStream.newOutputStringStream();

          stream001.nativeStream.print("`" + ((Keyword)(Stella.$CPP_NAME_QUALIFICATION_MODE$.get())) + "'" + " is not a valid case option");
          throw StellaException.newStellaException(stream001.theStringReader());
        }
      }
    }
  }

  public static String cppYieldNamespacePrefix(GeneralizedSymbol symbol) {
    return (Module.cppYieldNamespacePrefixFromModule(((Module)(symbol.homeContext))));
  }

  public static String helpCppChangeCase(GeneralizedSymbol symbol, Keyword caseconvention) {
    { Module module = ((Module)(symbol.homeContext));
      String name = symbol.symbolName;

      if (module == null) {
        module = ((Module)(Stella.$MODULE$.get()));
      }
      if (module.caseSensitiveP ||
          (!(Stella.computeSymbolEscapeCode(name, Stella.FALSE) == Stella.KWD_UNESCAPED))) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_NO, Stella.KWD_NO, "- ", "", "", "", "", Stella.KWD_PRESERVE, "_"));
      }
      if (caseconvention == Stella.KWD_UPPERCASE) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_NO, Stella.KWD_NO, "- ", "", "", "", "", Stella.KWD_UPCASE, "_"));
      }
      else if (caseconvention == Stella.KWD_LOWERCASE) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_CLEVER, Stella.KWD_CLEVER, "- ", "", "", "", "", Stella.KWD_TITLECASEX, ""));
      }
      else if (caseconvention == Stella.KWD_CAPITALIZED) {
        return (Stella.makeMatchingNameFull(name, Stella.KWD_CLEVER, Stella.KWD_CLEVER, "- ", "", "", "", "", Stella.KWD_TITLECASE, ""));
      }
      else {
        { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

          stream000.nativeStream.print("`" + caseconvention + "'" + " is not a valid case option");
          throw StellaException.newStellaException(stream000.theStringReader());
        }
      }
    }
  }

  public static String cppChangeCase(GeneralizedSymbol symbol, Keyword caseconvention) {
    { MemoizationTable memoTable000 = ((MemoizationTable)(Stella.SGT_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000.surrogateValue));
      Cons memoizedEntry000 = null;
      Stella_Object memoizedValue000 = null;

      if (memoTable000 == null) {
        Surrogate.initializeMemoizationTable(Stella.SGT_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000, "(:MAX-VALUES 2000)");
        memoTable000 = ((MemoizationTable)(Stella.SGT_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000.surrogateValue));
      }
      if (Stella.$MEMOIZATION_ENABLEDp$) {
        memoizedEntry000 = MruMemoizationTable.lookupMruMemoizedValue(((MruMemoizationTable)(memoTable000)), symbol, caseconvention, ((Module)(Stella.$MODULE$.get())), Stella.MEMOIZED_NULL_VALUE, -1);
        memoizedValue000 = memoizedEntry000.value;
      }
      if (memoizedValue000 != null) {
        if (memoizedValue000 == Stella.MEMOIZED_NULL_VALUE) {
          memoizedValue000 = null;
        }
      }
      else {
        memoizedValue000 = Stella.wrapString(GeneralizedSymbol.helpCppChangeCase(symbol, caseconvention));
        if (Stella.$MEMOIZATION_ENABLEDp$) {
          memoizedEntry000.value = ((memoizedValue000 == null) ? Stella.MEMOIZED_NULL_VALUE : memoizedValue000);
        }
      }
      { Stella_Object value000 = memoizedValue000;

        return (((StringWrapper)(value000)).wrapperValue);
      }
    }
  }

  public static GeneralizedSymbol registerSymbol(GeneralizedSymbol symbol) {
    symbol = ((GeneralizedSymbol)(symbol.permanentify()));
    { GeneralizedSymbol registeredsymbol = ((GeneralizedSymbol)(Stella.$SYMBOL_REGISTRY$.lookup(symbol)));

      if (!(registeredsymbol != null)) {
        Stella.$SYMBOL_SET$.insert(symbol);
        if (Stella.useHardcodedSymbolsP()) {
          registeredsymbol = symbol;
        }
        else {
          registeredsymbol = GeneralizedSymbol.createStartupSymbol(symbol);
        }
        Stella.$SYMBOL_REGISTRY$.insertAt(symbol, registeredsymbol);
      }
      return (registeredsymbol);
    }
  }

  public static Symbol createStartupSymbol(GeneralizedSymbol symbol) {
    { Module symbolmodule = ((Module)(Stella.$MODULE$.get()));
      Symbol symbolconstant = GeneralizedSymbol.yieldSymbolConstantName(symbol);
      String symbolconstantname = symbolconstant.symbolName;
      Stella_Object symbolconstanttypetree = StandardObject.yieldTypeSpecTree(symbol.primaryType());
      String lisppackage = symbolmodule.lispPackage();
      Cons tree = null;

      if (Stella.incrementalTranslationP()) {
      }
      tree = Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_DEFGLOBAL, Stella_Object.cons(symbolconstant, Stella_Object.cons(Stella_Object.cons(symbolconstanttypetree, Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_NULL, Stella_Object.cons(Stella.KWD_PUBLICp, Stella_Object.cons(Stella.SYM_STELLA_TRUE, Stella_Object.cons(Stella.NIL, Stella.NIL)))))), Stella.NIL))));
      Cons.walkAuxiliaryTree(tree);
      tree = Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_STARTUP_TIME_PROGN, Stella_Object.cons(Stella.KWD_SYMBOLS, Stella_Object.cons(Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_SETQ, Stella_Object.cons(symbolconstant, Stella_Object.cons(Stella_Object.cons(Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_SAFE_CAST, Stella_Object.cons(Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_INTERN_RIGID_SYMBOL_WRT_MODULE, Stella_Object.cons(Stella.wrapString(symbol.symbolName), Stella_Object.cons(Stella_Object.cons((((((Module)(symbol.homeContext)) == ((Module)(Stella.$MODULE$.get()))) ||
          Stella_Object.keywordP(symbol)) ? ((StandardObject)(Stella.SYM_STELLA_NULL)) : ((StandardObject)(Stella.list$(Stella_Object.cons(Stella.SYM_STELLA_GET_STELLA_MODULE, Stella_Object.cons(Stella.wrapString(((Module)(symbol.homeContext)).moduleFullName), Stella_Object.cons(Stella_Object.cons(Stella.SYM_STELLA_TRUE, Stella.NIL), Stella.NIL))))))), Stella_Object.cons(Stella.wrapInteger((Stella_Object.keywordP(symbol) ? Stella.KEYWORD_SYM : ((Stella_Object.surrogateP(symbol) ? Stella.SURROGATE_SYM : Stella.SYMBOL_SYM)))), Stella.NIL)), Stella.NIL)))), Stella_Object.cons(symbolconstanttypetree, Stella_Object.cons(Stella.NIL, Stella.NIL))))), Stella.NIL), Stella.NIL)))), Stella_Object.cons(Stella.NIL, Stella.NIL)))));
      Cons.walkAuxiliaryTree(tree);
      return (symbolconstant);
    }
  }

  public static Symbol yieldSymbolConstantName(GeneralizedSymbol symbol) {
    symbol = ((GeneralizedSymbol)(symbol.permanentify()));
    if (Surrogate.subtypeOfKeywordP(Stella_Object.safePrimaryType(symbol))) {
      { Keyword symbol000 = ((Keyword)(symbol));

        return (Stella.internSymbolInModule(Native.stringUpcase(GeneralizedSymbol.constructSymbolConstantName(symbol000)), ((Module)(Stella.$MODULE$.get())), Stella.TRUE));
      }
    }
    else {
      return (Stella.internSymbolInModule(Native.stringUpcase(GeneralizedSymbol.constructSymbolConstantName(symbol)), ((Module)(Stella.$MODULE$.get())), Stella.TRUE));
    }
  }

  public static String constructSymbolConstantName(GeneralizedSymbol symbol) {
    { String prefix = null;
      String environmentname = "";

      if (((Module)(symbol.homeContext)) != null) {
        environmentname = ((Module)(symbol.homeContext)).moduleName + "-";
      }
      if (!(Stella.incrementalTranslationP() ||
          (((Keyword)(Stella.$TRANSLATOROUTPUTLANGUAGE$.get())) == Stella.KWD_JAVA))) {
        environmentname = Native.stringUpcase(((String)(Stella.$CURRENTFILE$.get()))) + "-" + environmentname;
      }
      { Surrogate testValue000 = Stella_Object.safePrimaryType(symbol);

        if (Surrogate.subtypeOfSymbolP(testValue000)) {
          { Symbol symbol000 = ((Symbol)(symbol));

            prefix = "SYM-";
          }
        }
        else if (Surrogate.subtypeOfSurrogateP(testValue000)) {
          { Surrogate symbol000 = ((Surrogate)(symbol));

            prefix = "SGT-";
          }
        }
        else if (Surrogate.subtypeOfKeywordP(testValue000)) {
          { Keyword symbol000 = ((Keyword)(symbol));

            prefix = "KWD-";
          }
        }
        else {
          { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

            stream000.nativeStream.print("`" + testValue000 + "'" + " is not a valid case option");
            throw StellaException.newStellaException(stream000.theStringReader());
          }
        }
      }
      return (prefix + environmentname + symbol.symbolName);
    }
  }

  public static boolean explicitlyQualifiedNameP(GeneralizedSymbol name, Module definitionmodule) {
    { Module namemodule = ((Module)(name.homeContext));
      GeneralizedSymbol shadow = null;

      if (namemodule == definitionmodule) {
        {
          return (Stella.FALSE);
        }
      }
      else {
        if (!Context.visibleFromP(namemodule, definitionmodule)) {
          {
            return (Stella.TRUE);
          }
        }
        else {
          { boolean testValue000 = Stella.FALSE;

            { 
              shadow = Stella.lookupSymbolInModule(name.symbolName, definitionmodule, Stella.TRUE);
              testValue000 = shadow != null;
            }
            if (testValue000) {
              testValue000 = !(shadow == name);
            }
            if (testValue000) {
              {
                return (Stella.TRUE);
              }
            }
            else {
              {
                return (Stella.FALSE);
              }
            }
          }
        }
      }
    }
  }

  /** Return a global variable with name 'self'.
   * @return GlobalVariable
   */
  public GlobalVariable lookupGlobalVariable() {
    { GeneralizedSymbol self = this;

      return (((GlobalVariable)(Stella.$GLOBAL_VARIABLE_LOOKUP_TABLE$.lookup(((Symbol)(self))))));
    }
  }

  /** Return <code>true</code> if <code>symbol</code> is shadowed in its home module.
   * @param symbol
   * @return boolean
   */
  public static boolean shadowedSymbolP(GeneralizedSymbol symbol) {
    { String symbolname = symbol.symbolName;
      Module module = ((Module)(symbol.homeContext));

      { boolean testValue000 = Stella.FALSE;

        testValue000 = module != null;
        if (testValue000) {
          { boolean foundP000 = Stella.FALSE;

            { Surrogate shadow = null;
              Cons iter000 = module.shadowedSurrogates().theConsList;

              loop000 : while (!(iter000 == Stella.NIL)) {
                {
                  shadow = ((Surrogate)(iter000.value));
                  iter000 = iter000.rest;
                }
                if (Stella.stringEqlP(shadow.symbolName, symbolname)) {
                  foundP000 = Stella.TRUE;
                  break loop000;
                }
              }
            }
            testValue000 = foundP000;
          }
        }
        { boolean value000 = testValue000;

          return (value000);
        }
      }
    }
  }

  public String visibleName() {
    { GeneralizedSymbol self = this;

      { boolean visibleP = Stella.FALSE;

        { Surrogate testValue000 = Stella_Object.safePrimaryType(self);

          if (Surrogate.subtypeOfSymbolP(testValue000)) {
            { Symbol self000 = ((Symbol)(self));

              visibleP = self000 == Stella.lookupSymbolInModule(self000.symbolName, ((Module)(Stella.$MODULE$.get())), Stella.FALSE);
            }
          }
          else if (Surrogate.subtypeOfSurrogateP(testValue000)) {
            { Surrogate self000 = ((Surrogate)(self));

              visibleP = self000 == Stella.lookupSurrogateInModule(self000.symbolName, ((Module)(Stella.$MODULE$.get())), Stella.FALSE);
            }
          }
          else {
            { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

              stream000.nativeStream.print("`" + testValue000 + "'" + " is not a valid case option");
              throw StellaException.newStellaException(stream000.theStringReader());
            }
          }
        }
        if (visibleP) {
          return (self.localPrintName());
        }
        else {
          return (Stella.computeFullName(self.localPrintName(), ((Module)(self.homeContext))));
        }
      }
    }
  }

  public String relativeName() {
    { GeneralizedSymbol self = this;

      { String string = null;

        if (((Module)(self.homeContext)) == ((Module)(Stella.$MODULE$.get()))) {
          string = self.localPrintName();
        }
        else {
          string = Stella.computeFullName(self.localPrintName(), ((Module)(self.homeContext)));
        }
        if (self.symbolId == -1) {
          string = "<<UNINTERNED>>/" + string;
        }
        return (string);
      }
    }
  }

  public String localPrintName() {
    { GeneralizedSymbol self = this;

      return (self.symbolName);
    }
  }

  public Keyword keywordify() {
    { GeneralizedSymbol self = this;

      return (Stella.internKeyword(self.symbolName));
    }
  }

  public boolean deletedP() {
    { GeneralizedSymbol self = this;

      return (self.symbolId == -1);
    }
  }

  /** Return a newly-created or existing surrogate with name
   * <code>newname</code> which is interned in the same module as <code>basesymbol</code>.
   * @param basesymbol
   * @param newname
   * @return Surrogate
   */
  public static Surrogate internDerivedSurrogate(GeneralizedSymbol basesymbol, String newname) {
    { Module currentmodule = ((Module)(Stella.$MODULE$.get()));

      { Object old$Module$000 = Stella.$MODULE$.get();

        try {
          edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, ((Module)(basesymbol.homeContext)));
          if (((Module)(Stella.$MODULE$.get())) != null) {
            return (((Surrogate)(Stella.internRigidSymbolLocally((((Module)(Stella.$MODULE$.get())).caseSensitiveP ? newname : Native.stringUpcase(newname)), ((Module)(Stella.$MODULE$.get())), Stella.SURROGATE_SYM))));
          }
          edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, currentmodule);
          return (Stella.internSurrogate(newname));

        } finally {
          Stella.$MODULE$.set(old$Module$000);
        }
      }
    }
  }

  /** Return a newly-created or existing symbol with name
   * <code>newname</code> which is interned in the same module as <code>basesymbol</code>.
   * @param basesymbol
   * @param newname
   * @return Symbol
   */
  public static Symbol internDerivedSymbol(GeneralizedSymbol basesymbol, String newname) {
    { Module currentmodule = ((Module)(Stella.$MODULE$.get()));

      { Object old$Module$000 = Stella.$MODULE$.get();

        try {
          edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, ((Module)(basesymbol.homeContext)));
          if (((Module)(Stella.$MODULE$.get())) != null) {
            return (((Symbol)(Stella.internRigidSymbolLocally((((Module)(Stella.$MODULE$.get())).caseSensitiveP ? newname : Native.stringUpcase(newname)), ((Module)(Stella.$MODULE$.get())), Stella.SYMBOL_SYM))));
          }
          edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, currentmodule);
          return (Stella.internSymbol(newname));

        } finally {
          Stella.$MODULE$.set(old$Module$000);
        }
      }
    }
  }

  public static boolean generalizedSymbolLessThanP(GeneralizedSymbol x, GeneralizedSymbol y) {
    return (Stella.stringL(x.symbolName, y.symbolName));
  }

  public static Stella_Object accessGeneralizedSymbolSlotValue(GeneralizedSymbol self, Symbol slotname, Stella_Object value, boolean setvalueP) {
    if (slotname == Stella.SYM_STELLA_SYMBOL_NAME) {
      if (setvalueP) {
        self.symbolName = ((StringWrapper)(value)).wrapperValue;
      }
      else {
        value = Stella.wrapString(self.symbolName);
      }
    }
    else if (slotname == Stella.SYM_STELLA_SYMBOL_ID) {
      if (setvalueP) {
        self.symbolId = ((IntegerWrapper)(value)).wrapperValue;
      }
      else {
        value = Stella.wrapInteger(self.symbolId);
      }
    }
    else if (slotname == Stella.SYM_STELLA_INTERNED_IN) {
      if (setvalueP) {
        self.homeContext = ((Module)(value));
      }
      else {
        value = ((Module)(self.homeContext));
      }
    }
    else {
      { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

        stream000.nativeStream.print("`" + slotname + "'" + " is not a valid case option");
        throw StellaException.newStellaException(stream000.theStringReader());
      }
    }
    return (value);
  }

}

